! WHIZARD 2.2.7 Aug 11 2015
! 
! Copyright (C) 1999-2015 by 
!     Wolfgang Kilian <kilian@physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@desy.de>
!     
!     with contributions from
!     Fabian Bach <fabian.bach@desy.de>
!     Christian Speckner <cnspeckn@googlemail.com> 
!     Christian Weiss <christian.weiss@desy.de>
!     and Hans-Werner Boschmann, Felix Braam, 
!     Sebastian Schmidt, Daniel Wiesler 
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file has been stripped of most comments.  For documentation, refer
! to the source 'whizard.nw'

module mci_base_ut
  use unit_tests
  use mci_base_uti
  
  implicit none
  private

  public :: mci_base_test

  public :: mci_test_t

contains
  
  subroutine mci_base_test (u, results)
    integer, intent(in) :: u
    type(test_results_t), intent(inout) :: results
    call test (mci_base_1, "mci_base_1", &
         "integrator configuration", &
         u, results)
    call test (mci_base_2, "mci_base_2", &
         "integration", &
         u, results)
    call test (mci_base_3, "mci_base_3", &
         "integration (two channels)", &
         u, results)
    call test (mci_base_4, "mci_base_4", &
         "event generation (two channels)", &
         u, results)
    call test (mci_base_5, "mci_base_5", &
         "store and recall", &
         u, results)
    call test (mci_base_6, "mci_base_6", &
         "chained channels", &
         u, results)
    call test (mci_base_7, "mci_base_7", &
         "recording results", &
         u, results)
    call test (mci_base_8, "mci_base_8", &
         "timer", &
         u, results)
  end subroutine mci_base_test
  

end module mci_base_ut
