! WHIZARD 2.2.7 Aug 11 2015
! 
! Copyright (C) 1999-2015 by 
!     Wolfgang Kilian <kilian@physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@desy.de>
!     
!     with contributions from
!     Fabian Bach <fabian.bach@desy.de>
!     Christian Speckner <cnspeckn@googlemail.com> 
!     Christian Weiss <christian.weiss@desy.de>
!     and Hans-Werner Boschmann, Felix Braam, 
!     Sebastian Schmidt, Daniel Wiesler 
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file has been stripped of most comments.  For documentation, refer
! to the source 'whizard.nw'

module pdg_arrays_ut
  use unit_tests
  use pdg_arrays_uti
  
  implicit none
  private

  public :: pdg_arrays_test

contains
  
  subroutine pdg_arrays_test (u, results)
    integer, intent(in) :: u
    type (test_results_t), intent(inout) :: results
    call test (pdg_arrays_1, "pdg_arrays_1", &
         "create and sort PDG array", &
         u, results) 
    call test (pdg_arrays_2, "pdg_arrays_2", &
         "create and sort PDG lists", &
         u, results) 
    call test (pdg_arrays_3, "pdg_arrays_3", &
         "check PDG lists", &
         u, results) 
    call test (pdg_arrays_4, "pdg_arrays_4", &
         "compare PDG lists", &
         u, results) 
    call test (pdg_arrays_5, "pdg_arrays_5", &
         "match PDG lists", &
         u, results)   
  end subroutine pdg_arrays_test


end module pdg_arrays_ut
